/***
 * Excerpted from "iCloud for Developers",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/cricloud for more book information.
***/
//
//  SMGroceryItem.m
//  grocery
//
//  Created by cesarerocchi on 6/5/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "SMGroceryItem.h"

NSString* const groceryItemUpdated = @"com.studiomagnolia.grocery.itemUpdated";

@implementation SMGroceryItem

// called when the application reads data from the file
- (BOOL) loadFromContents:(id)contents 
                   ofType:(NSString *)typeName 
                    error:(NSError **)outError {

    if ([contents length] > 0) {
    
        self.itemName = [[NSString alloc] initWithBytes:[contents bytes] 
                                                 length:[contents length]
                                               encoding:NSUTF8StringEncoding];
        
    } else {
    
        self.itemName = @"Unnamed item";
        
    }
    
    return YES;
    
}

// called when the app (auto)saves the content to the file
- (id) contentsForType:(NSString *)typeName 
                 error:(NSError **)outError {

    if ([self.itemName length] == 0) {
    
        self.itemName = @"Unnamed item";
        
    }
    
    [[NSNotificationCenter defaultCenter] postNotificationName:groceryItemUpdated
                                                        object:self];
    
    return [NSData dataWithBytes:[self.itemName UTF8String]
                          length:[self.itemName length]];
    
}


+ (SMGroceryItem *) createNewItem {
        
    NSString *fileName = [NSString stringWithFormat:@"Item_%@",
                          [SMGroceryItem buildUUID]];
    
    NSURL *ubiqContainer = [[NSFileManager defaultManager]
                            URLForUbiquityContainerIdentifier:nil];
    
    NSURL *newItemUrl = [[ubiqContainer
                          URLByAppendingPathComponent:@"Documents"]
                         URLByAppendingPathComponent:fileName];
    
    return [[SMGroceryItem alloc] initWithFileURL:newItemUrl];
    
}

+ (NSString *)buildUUID {
    
    CFUUIDRef theUUID = CFUUIDCreate(NULL);
    NSString *uuidString = 
		(__bridge_transfer NSString *)CFUUIDCreateString(NULL, theUUID);
    CFRelease(theUUID);
    return uuidString;
    
}


@end
